config/routes.rb
Rails.application.routes.draw do
  get 'home/index'

  devise_for :users

  root 'home#index'
  resources :bookings
  resources :check_room_availabilities, :only => ['new', 'create']
  get "/thank-you" => "static_pages#index", :as => "thank_you"

  namespace :api do
    namespace :v1 do
      get '/get_available_rooms' => 'available_rooms#get_available_rooms'
    end 
  end

end

app/models/booking.rb
class Booking < ActiveRecord::Base

	belongs_to :room
	belongs_to :user

	def self.check_for_available_rooms(params)
		booked_room_ids = Booking.where("(check_in_date BETWEEN ? AND ?) OR (check_out_date BETWEEN ? AND ?) or (check_in_date <= ? AND check_out_date >= ?)", params[:check_in_date].to_date, params[:check_out_date].to_date, params[:check_in_date].to_date, params[:check_out_date].to_date, params[:check_in_date].to_date, params[:check_out_date].to_date).pluck(:room_id)
		if booked_room_ids.blank?
			if params[:category_id].present?
				available_rooms = Room.joins(:category).where('categories.id = ?', params[:category_id]) 
			else
				available_rooms = Room.all 
			end
		else
			if params[:category_id].present?
				available_rooms = Room.where('rooms.id NOT IN (?)', booked_room_ids).joins(:category).where('categories.id = ?', params[:category_id])
			else
				available_rooms = Room.where('rooms.id NOT IN (?)', booked_room_ids)
			end	
		end
		return available_rooms
	end

	def self.book_room(room_id, params)
		Booking.create(:room_id => room_id, :check_in_date => params[:check_in_date], :check_out_date => params[:check_out_date], :user_id => params[:user_id])
	end

	def self.get_booking_record(id)
		Booking.includes(:room).find_by_id(id)
	end

end

app/models/category.rb
class Category < ActiveRecord::Base
	has_many :rooms
end

app/models/check_room_availability.rb
class CheckRoomAvailability
  include ActiveModel::Model

  #This model is not database backed, we are not storing any data over here, we have just created this model for validation purposes using ActiveModel Gem

  attr_accessor :category_id, :check_in_date, :check_out_date
  validates :category_id, :presence => { :message => "Please select room category" }
  validates :check_in_date, :presence => { :message => "Please select check-in date" }
  validates :check_out_date, :presence => { :message => "Please select check-out date" }

	validate :booking_till_max_6_months
	validate :check_valid_dates

	def check_valid_dates
		if self.check_in_date.present? and self.check_out_date.present?
			errors.add(:check_out_date, message: "Check-out date can't be less than check-in date")  if self.check_in_date.to_date  > self.check_out_date.to_date
			errors.add(:base, message: "Please enter valid dates")  if self.check_in_date.to_date  < Date.today or self.check_out_date.to_date < Date.today
		end	
	end

	def booking_till_max_6_months
		errors.add(:base, message: "Booking is allowed only for 6 months from now") if self.check_in_date.present? and self.check_out_date.present? and (self.check_in_date.to_date  > (Date.today + 6.months) or self.check_out_date.to_date  > (Date.today + 6.months))
	end
end

app/models/room.rb
class Room < ActiveRecord::Base
	has_many :bookings, :dependent => :destroy
	belongs_to :category
end

app/models/user.rb
class User < ActiveRecord::Base
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  has_many :bookings, :dependent => :destroy       

  before_create :set_auth_token

  private
	  def set_auth_token
	    return if auth_token.present?
	    self.auth_token = generate_auth_token
	  end

	  def generate_auth_token
	    SecureRandom.uuid.gsub(/\-/,'')
	  end
end

app/controllers/api/v1/available_rooms_controller.rb
class Api::V1::AvailableRoomsController < ApplicationController
	
	# below filter is used for token based user authentication(when user is created a random authentication token is generated for that user, which will be used when calling an API)
	before_action :authenticate

	require 'rubygems'
	require 'json'


	def get_available_rooms

		unless params[:check_in_date].present?
			render :status => 401, :json => {:status => "Failure", :message => "Check In is required."}
			return true
		end

		unless params[:check_out_date].present?
			render :status => 401, :json => {:status => "Failure", :message => "Check Out is required."}
			return true
		end

		if params[:room_type].present?
			category = Category.find_by_name(params[:room_type])
			category_id = category.id if category.present?

			unless category.present?
				render :status => 401, :json => {:status => "Failure", :message => "Could not find room with given type."}
				return true
			end		
		end	

		params[:category_id] = category_id
		# here I amhaving class method for Booking class for checking available rooms(common methos is being used for web app and API)
		@available_rooms = Booking.check_for_available_rooms(params)
		# If rooms are not available for given time period the below message is displayed for the user and fi rooms are available then .jbuilder template is rendered
		unless @available_rooms.present?
			render :status => 401, :json => {:status => "Successful", :message => "Sorry! no rooms are available."}
			return true
		end
	end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
  skip_before_action :verify_authenticity_token

def after_sign_in_path_for(resource)
  root_path
end

protected
  def authenticate
    if user_signed_in?
	    user = User.find_by(auth_token: params[:token])
	    unless user.present?
	    	render :status => 404, :json => {:status => "Failure", :message => "Unauthorized User."}
	    end
	  else
	  	render :status => 404, :json => {:status => "Failure", :message => "Unauthorized User."}
	  end  
  end

end

app/controllers/bookings_controller.rb
class BookingsController < ApplicationController
	
  before_action :authenticate_user!

  def index
    # room objects are eager_loaded for query efficiency using 'includes'
    @bookings= current_user.bookings.includes(:room)
  end

  def new
    @available_rooms = Booking.check_for_available_rooms(params)    
  end

  def create
    unless params[:room_ids].present?
      session[:blank_checkboxes] = true
      return redirect_to :back
    end
    booking_ids =[]
    params[:room_ids].each do |room_id|
      booking = Booking.book_room(room_id, params)
      booking_ids << booking.id
    end
    redirect_to thank_you_path(:ids => booking_ids)
  end

  def destroy
    @booking = Booking.find(params[:id])
    @booking.destroy
    redirect_to bookings_path
  end

  protected

  def booking_params
    params.require(:booking).permit!
  end

end

app/controllers/check_room_availabilities_controller.rb
class CheckRoomAvailabilitiesController < ApplicationController
	
	before_action :authenticate_user!

	def new
		@check_room_availability = CheckRoomAvailability.new
	end

	def create
		@check_room_availability = CheckRoomAvailability.new(check_room_availability_params)
		if @check_room_availability.valid?
			redirect_to new_booking_path(:category_id => params[:check_room_availability][:category_id], :check_in_date => params[:check_room_availability][:check_in_date], :check_out_date => params[:check_room_availability][:check_out_date])
		else
			render 'new'
		end
	end

	protected

  def check_room_availability_params
    params.require(:check_room_availability).permit!
  end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController

end

app/controllers/static_pages_controller.rb
class StaticPagesController < ApplicationController
  before_action :authenticate_user!

  #this is controller is generated to serve static pages n all 	
end

app/helpers/api/v1/available_rooms_helper.rb
module Api::V1::AvailableRoomsHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/bookings_helper.rb
module BookingsHelper
end

app/helpers/check_room_availabilities_helper.rb
module CheckRoomAvailabilitiesHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/static_pages_helper.rb
module StaticPagesHelper
end

app/views/bookings/_form.html.haml
-	if @available_rooms.present?
	= form_tag "/bookings", :method => 'POST' do 
		.panel.panel-default
			.panel-heading Below is the list of available rooms
			.panel-heading 
				= "Room Type : "
				= @available_rooms.last.category.name.capitalize
				= ", "
				= "Description : "
				= @available_rooms.last.category.description.capitalize
			%table.table
				%th Room Number
				%th Select Rooms To Book 
				- @available_rooms.each do |room|
					%tr
						%td
							= room.room_number
						%td
							= check_box_tag "room_ids[]", room.id, false, :class => 'check'
				= hidden_field_tag :check_in_date, params[:check_in_date]
				= hidden_field_tag :check_out_date, params[:check_out_date]
				= hidden_field_tag :user_id, current_user.id
		
		=# Below button is initially diabled, when user selects atleast one room at that time this button gets enabled(Kindly check common.js file for the same)
		= submit_tag "Book Now", :disabled => 'disabled', :id => 'sub', :class => "btn btn-success"

- else
	.jumbotron
		%h3 Sorry, no rooms are available!
		%p ...
		%p
			%a.btn.btn-primary.btn-lg{:href => "#{root_path}", :role => "button"} Go Back

- if session[:blank_checkboxes].present?
	%p.message Please choose atleast one room to book
	- session[:blank_checkboxes] = nil

app/views/bookings/index.html.haml
- if @bookings.present?
	.panel.panel-default
		.panel-heading Booking done by me!
	%table.table
		%th Room Number 
		%th Room Type
		%th Check In Date
		%th Check Out Date
		%th Action
		- @bookings.each do |booking|
			%tr
				%td
					= booking.room.room_number
				%td
					= booking.room.category.name.capitalize
				%td
					= booking.check_in_date.strftime("%A, %d %b %Y")	
				%td
					= booking.check_out_date.strftime("%A, %d %b %Y")			
				%td 
					- if booking.check_in_date > Date.today
						= link_to 'Cancel Booking',  booking,  method: :delete, :class => "btn btn-default cancel-btn",data: { confirm: 'Are you sure, you want to cancel this booking?' }
- else
	.panel.panel-default
		.panel-heading Seems you have not booked any rooms yet!			
	= link_to "Book Now", new_check_room_availability_path, class: "active btn btn-primary"

app/views/bookings/new.html.haml
= render 'form'

app/views/check_room_availabilities/_form.html.haml
- if @check_room_availability.errors.full_messages.any?
  .jumbotron
    %h5 Please resolve below errors

    - @check_room_availability.errors.each do |key, val|
      %li.message
        = key
        = ':' 
        = val

= form_for @check_room_availability do |f|
  .form-group
    %label{:for => "exampleInputEmail1"} Room Type
    = f.select(:category_id, options_for_select(Category.all.map{ |c| [c.name, c.id]}, f.object.category_id), {:include_blank => 'Select Category'}, { :class => 'form-control' })
  .form-group
    %label{:for => "exampleInputPassword1"} Check-In Date
    = f.text_field :check_in_date, :class => "datepicker form-control"
  .form-group
    %label{:for => "exampleInputPassword1"} Check-Out Date
    = f.text_field :check_out_date, :class => "datepicker form-control"  
  
  = submit_tag 'View Available Rooms', :class => 'btn btn-primary'

app/views/check_room_availabilities/new.html.haml
= render 'form'

app/views/home/index.html.haml
.jumbotron
  %h2 Welcome to hotel, Parineeta Cube!
  %p
    = link_to "Book Room", new_check_room_availability_path, class: "btn btn-primary btn-lg"
    = link_to "View my bookings", bookings_path, class: "btn btn-success btn-lg"

app/views/layouts/_header.html.haml
%nav.navbar.navbar-default{:role => "navigation"}
  .container
    .navbar-header
      %button.navbar-toggle.collapsed{"data-target" => "#bs-example-navbar-collapse-1", "data-toggle" => "collapse", :type => "button"}
        %span.sr-only Toggle navigation
        %span.icon-bar
        %span.icon-bar
        %span.icon-bar
      = link_to "Hotel Management", root_path, class: "navbar-brand"
    / Collect the nav links, forms, and other content for toggling
    #bs-example-navbar-collapse-1.collapse.navbar-collapse
      %ul.nav.navbar-nav
        - if user_signed_in?
          %li= link_to "Book Room", new_check_room_availability_path, class: "active"
          %li= link_to "View my bookings", bookings_path
          %li= link_to "Sign Out", destroy_user_session_path, :method => 'delete', class: "active"
        - else
          %li= link_to "Sign Up", new_user_registration_path, class: "active"
          %li= link_to "Sign In", new_user_session_path, class: "active"
     

app/views/layouts/application.html.haml
!!!
%html
	%head
		%meta{:content => "text/html; charset=UTF-8", "http-equiv" => "Content-Type"}/
		%title HotelManagement
		= stylesheet_link_tag    'application', media: 'all'
		= javascript_include_tag 'application'
		= csrf_meta_tags
	%body
		= render 'layouts/header'
		.container
			= yield

app/views/static_pages/index.html.haml
%h1 Booking Successful

%h3 Booking Details

- if params[:ids].present?
	%table.table
		%th Room Number
		%th Room Type
		%th Check_In date
		%th Check_Out date
		- params[:ids].each do |id|
			- record = Booking.get_booking_record(id)
			- if record.present?				
				%tr 
					%td 
						= record.room.room_number
					%td
						= record.room.category.name.capitalize
					%td
						= record.check_in_date.strftime("%A, %d %b %Y")
					%td
						= record.check_out_date.strftime("%A, %d %b %Y")
							
							
= link_to 'Home', root_path, :class => "btn btn-primary"